;==================================================================
;Project Title:     Lil terrestrial globe
;Author:     MadMedic
;Email:      MadMedic@rambler.ru
;==================================================================
Graphics3D 640,480,0,2
SetBuffer BackBuffer()
; 
SetFont LoadFont("Arial",22)
;    :
earth=CreateSphere(50)

ScaleEntity earth,20,20,20			;           ( )
earthT=LoadTexture("earth.jpg")  
EntityTexture earth,eartht 
EntityPickMode earth,2				;       

c=CreateCube()					;   
EntityColor c,255,0,0		;      

CamPivot=CreatePivot()				; 
cam=CreateCamera(CamPivot)		;
destzoom#=-50							;  
							;>>> <<<
Repeat
;     
mys#=MouseYSpeed()
mxs#=MouseXSpeed()
mzs#=MouseZSpeed()
;    ,       
If MouseDown(2)
destpicth#=campitch#+Mys#*4		;       
destyaw#=camyaw#-Mxs#*4		; (Destination -  )
; (4)    !
EndIf
;      Z
If mzs<>0
destzoom#=camzoom#+Mzs#*5   ;      !
EndIf
;    
If MouseDown(1)				;   Mousehit(1)
e=CameraPick(cam,MouseX(),MouseY())			;     
	If e Then													; ,       3d
	destyaw#=VectorYaw(PickedX()*-1,PickedY()*-1,PickedZ()*-1);       
	destpicth#=VectorPitch(PickedX()*-1,PickedY()*-1,PickedZ()*-1)	;	 
	PositionEntity c,PickedX(),PickedY(),PickedZ()		;     (   )
	EndIf
EndIf

campitch#=ToVar(campitch#,destpicth#,0.05)			;   

If campitch#>90 Then campitch#=90							;    
If campitch#<-90 Then campitch#=-90

If destyaw-camyaw>180							;    yaw() 
While destyaw-camyaw>180					;     180
destyaw=destyaw-360							;   
Wend
EndIf

If camyaw-destyaw>180
While camyaw-destyaw>180
destyaw=destyaw+360
Wend
EndIf

camyaw#=ToVar(camyaw#,destyaw#,0.05)		;   (yaw)

camzoom#=ToVar(camzoom#,destzoom#,0.1)	;    
If camzoom#>-21 Then camzoom#=-21				; = +1		;      

RotateEntity CamPivot,campitch#,camyaw#,0		;      
PositionEntity cam,0,0,camzoom#						;   

UpdateWorld
RenderWorld
Text 320,20,"Right mouse to rotate terrestrial globe",1,1
Text 320,40,"Left mouse on sphere to show this place",1,1
Text 320,60,"Use scroll to zoom",1,1

Text 320,460,"By MadMedic",1,1
Flip
If KeyHit(1) Then Exit
Forever
End
;


Function ToVar#(v1#, v2#, dt#) ;by Arkon   
      If v1# <> v2# 
            vvv# = v2# - v1# 
            rt# = v1# + (v2# - v1#) * dt# 
            If Sgn(vvv) <> Sgn(v2# - rt#) Then rt# = v2# 
      Else 
            rt# = v2# 
      EndIf 
      Return rt# 
End Function
